## seqan-needle 1.0.1.0.0.git.3011926%2Bds

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,repacksuffix=+ds" \
  https://github.com/seqan/needle/tags (?:.*?/)?needle-v?@ANY_VERSION@@ARCHIVE_EXT@

## seqan-needle 1.0.1.0.0.git.3011926+ds

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

## CUSTOMISE

# Define the application name and version.
project (needle VERSION 1.0.0)

## BUILD

# Make Release default build type
if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
         "Choose the type of build, options are: Debug Release Coverage RelWithDebInfo MinSizeRel."
         FORCE)
endif ()

# Specify the directories where to store the built archives, libraries and executables
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

# Messages
string (ASCII 27 Esc)
set (FontBold "${Esc}[1m")
set (FontReset "${Esc}[m")

# Dependency: SeqAn3.
find_package (SeqAn3 QUIET REQUIRED HINTS lib/seqan3/build_system)

# Use ccache.
include ("${SEQAN3_CLONE_DIR}/test/cmake/seqan3_require_ccache.cmake")
seqan3_require_ccache ()

# Dependency: robin_hood.
add_subdirectory(lib/robin-hood-hashing)

# Add the application.
add_subdirectory (src)
message (STATUS "${FontBold}You can run `make` to build the application.${FontReset}")


## DOCUMENTATION

add_subdirectory (doc EXCLUDE_FROM_ALL)

## TEST

enable_testing ()
add_subdirectory (test EXCLUDE_FROM_ALL)

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

# Find doxygen.
find_package (Doxygen 1.9.4 QUIET)

if (${DOXYGEN_FOUND})
    message (STATUS "Found Doxygen: ${DOXYGEN_EXECUTABLE}")

    # Configure doxygen options.
    set (APP_TEMPLATE_DOXYFILE_IN ${CMAKE_SOURCE_DIR}/doc/doxygen_cfg)
    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}/doc")
    set (APP_TEMPLATE_DOXYGEN_EXCLUDE_SYMBOLS "")
    set (APP_TEMPLATE_DOXYGEN_PREDEFINED_NDEBUG "")
    set (APP_TEMPLATE_DOXYGEN_ENABLED_SECTIONS "DEV")
    set (APP_TEMPLATE_DOXYGEN_EXTRACT_PRIVATE "YES")

    configure_file (${APP_TEMPLATE_DOXYFILE_IN} ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}/Doxyfile)
    add_custom_target (doc
                       COMMAND ${DOXYGEN_EXECUTABLE}
                       WORKING_DIRECTORY ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}
                       COMMENT "Generating (developer) API documentation with Doxygen."
                       VERBATIM)
    message (STATUS "${FontBold}You can run `make doc` to build api documentation.${FontReset}")
else ()
    message (STATUS "Doxygen not found.")
endif ()

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

find_package(OpenMP REQUIRED)
add_library ("${PROJECT_NAME}_lib" STATIC ibf.cpp estimate.cpp)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC seqan3::seqan3)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC robin_hood)
target_link_libraries("${PROJECT_NAME}_lib" PUBLIC OpenMP::OpenMP_CXX)

target_include_directories ("${PROJECT_NAME}_lib" PUBLIC ../include)

add_executable ("${PROJECT_NAME}" main.cpp)
target_link_libraries ("${PROJECT_NAME}" PRIVATE "${PROJECT_NAME}_lib")

=== test/api/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

# The api_test build target.
add_api_test (count_test.cpp)
add_api_test (estimate_test.cpp)
add_api_test (ibf_test.cpp)
add_api_test (ibfmin_test.cpp)
add_api_test (minimiser_test.cpp)

=== test/cli/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

add_cli_test (needle_options_test.cpp)
add_cli_test (ibf_options_test.cpp)
target_use_datasources (ibf_options_test FILES exp_01.fasta mini_example.fasta mini_example.minimiser)
add_cli_test (minimiser_options_test.cpp)
target_use_datasources (minimiser_options_test FILES mini_example.fasta)
add_cli_test (estimate_options_test.cpp)
target_use_datasources (estimate_options_test FILES IBF_1 mini_gen.fasta)
add_cli_test (count_options_test.cpp)
target_use_datasources (count_options_test FILES mini_example.fasta mini_gen.fasta)

=== lib/robin-hood-hashing/src/test/app/fmt/CMakeLists.txt ===
target_sources_local(rh PRIVATE
    bin.h
    hex.h
    mup.h
    mup.cpp
    streamstate.cpp
    streamstate.h
)

=== lib/robin-hood-hashing/src/test/app/hash/CMakeLists.txt ===
target_sources_local(rh PRIVATE
    Bad.h
    FNV1a.h
    Identity.h
)

=== debian/changelog ===
seqan-needle (1.0.1.0.0.git.3011926+ds-4) unstable; urgency=medium

  * Team upload.
  * Create doc without previous binary build
    Closes: #1024458

 -- Andreas Tille <tille@debian.org>  Thu, 24 Nov 2022 11:38:47 +0100

seqan-needle (1.0.1.0.0.git.3011926+ds-3) unstable; urgency=medium

  * Team Upload.
  * Really move needle to usr/lib/debian-med/bin (Closes: #1023807)
  * d/rules: Fix arch:all build (Closes: #1024458)
  * Disable i386 in salsa-ci.yml since seqan-needle does not build on 32-bit

 -- Nilesh Patra <nilesh@debian.org>  Tue, 22 Nov 2022 19:54:37 +0530

seqan-needle (1.0.1.0.0.git.3011926+ds-2) unstable; urgency=medium

  * Rename binary to seqan-needle, add symlink and README.Debian
    Closes: #1023807

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 16 Nov 2022 17:00:44 +0100

seqan-needle (1.0.1.0.0.git.3011926+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1023322)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Oct 2022 18:58:32 +0200

=== debian/control ===
Source: seqan-needle
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libseqan3-dev (>= 3.2.0+ds-5),
               libgtest-dev,
               libcereal-dev,
               pkg-config,
               doxygen <!nodoc>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle
Vcs-Git: https://salsa.debian.org/med-team/seqan-needle.git
Homepage: https://github.com/seqan/needle
Rules-Requires-Root: no

Package: seqan-needle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: pre-filter for the counting of very large collections of nucleotide sequences
 Needle is a tool for semi-quantitative analysis of very large collections of
 nucleotide sequences.
 .
 Needle stores its data in multiple interleaved Bloom filter, a fast and space
 efficient probabilistic data structure and uses a windowing scheme (also called
 minimisers) to reduce the amount of data to store. How many interleaved Bloom
 filter are used is defined by the user. Each interleaved Bloom filter has a so
 called expression threshold and stores minimisers with an occurrence greater
 than or equal to its own expression threshold and smaller than the next biggest
 expression threshold (if there is no bigger expression threshold, all greater
 than or equal to the threshold are stored). These expression thresholds are
 then used during the query (called estimate) to approximate the expression
 values of given transcripts.

Package: seqan-needle-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Multi-Arch: foreign
Description: HTML documentation for seqan-needle and its APIs
 Needle is a tool for semi-quantitative analysis of very large collections of
 nucleotide sequences.
 .
 Needle stores its data in multiple interleaved Bloom filter, a fast and space
 efficient probabilistic data structure and uses a windowing scheme (also called
 minimisers) to reduce the amount of data to store. How many interleaved Bloom
 filter are used is defined by the user. Each interleaved Bloom filter has a so
 called expression threshold and stores minimisers with an occurrence greater
 than or equal to its own expression threshold and smaller than the next biggest
 expression threshold (if there is no bigger expression threshold, all greater
 than or equal to the threshold are stored). These expression thresholds are
 then used during the query (called estimate) to approximate the expression
 values of given transcripts.
 .
 This package contains Needle's HTML docs.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	rm -Rf lib/seqan3
	dh_auto_configure -- -DSEQAN3_NO_LEMON=OFF

override_dh_auto_build-arch:
	dh_auto_build --arch
	obj-*/bin/needle --export-help man > debian/needle.1
	obj-*/bin/needle count --export-help man > debian/needle-count.1
	obj-*/bin/needle estimate --export-help man > debian/needle-estimate.1
	obj-*/bin/needle ibf --export-help man > debian/needle-ibf.1
	obj-*/bin/needle minimiser --export-help man > debian/needle-minimiser.1

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	doxygen doc/doxygen_cfg
endif

override_dh_auto_test-indep:
	echo "Do Nothing"

## seqan-needle 1.0.1.0.1.git.439eeab+ds

=== test/cli/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

add_cli_test (needle_options_test.cpp)
add_cli_test (ibf_options_test.cpp)
target_use_datasources (ibf_options_test FILES exp_01.fasta mini_example.fasta mini_example.minimiser)
add_cli_test (insert_options_test.cpp)
target_use_datasources (insert_options_test FILES exp_01.fasta mini_example.fasta mini_example.minimiser)
add_cli_test (minimiser_options_test.cpp)
target_use_datasources (minimiser_options_test FILES mini_example.fasta)
add_cli_test (estimate_options_test.cpp)
target_use_datasources (estimate_options_test FILES IBF_1 mini_gen.fasta)
add_cli_test (count_options_test.cpp)
target_use_datasources (count_options_test FILES mini_example.fasta mini_gen.fasta mini_gen.genome)
add_cli_test (delete_options_test.cpp)

=== debian/changelog ===
seqan-needle (1.0.1.0.1.git.439eeab+ds-1) unstable; urgency=medium

  * New upstream snapshot with gcc-12 compatibility Closes: #1037855
  * d/patches: refresh; drop spelling patch (applied upstream).
  * d/patches: cherry-pick from upstream for Seqan 3.3.0
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Bug-Submit.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 17:41:39 +0200

## seqan-needle 1.0.2%2Bds

=== test/coverage/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

# Add a custom build type: Coverage

set (CMAKE_CXX_FLAGS_COVERAGE
     "${CMAKE_CXX_FLAGS_DEBUG} --coverage -fprofile-arcs -ftest-coverage" CACHE STRING
     "Flags used by the C++ compiler during coverage builds."
     FORCE)
set (CMAKE_C_FLAGS_COVERAGE
     "${CMAKE_C_FLAGS_DEBUG} --coverage -fprofile-arcs -ftest-coverage" CACHE STRING
     "Flags used by the C compiler during coverage builds."
     FORCE)
set (CMAKE_EXE_LINKER_FLAGS_COVERAGE
     "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-lgcov" CACHE STRING
     "Flags used for linking binaries during coverage builds."
     FORCE)
set (CMAKE_SHARED_LINKER_FLAGS_COVERAGE
     "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -Wl,-lgcov" CACHE STRING
     "Flags used by the shared libraries linker during coverage builds."
     FORCE)

mark_as_advanced (
    CMAKE_CXX_FLAGS_COVERAGE
    CMAKE_C_FLAGS_COVERAGE
    CMAKE_EXE_LINKER_FLAGS_COVERAGE
    CMAKE_SHARED_LINKER_FLAGS_COVERAGE)

## seqan-needle 1.0.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,3 +47,19 @@
 
 enable_testing ()
 add_subdirectory (test EXCLUDE_FROM_ALL)
+
+set (CPACK_GENERATOR "TXZ")
+
+set (CPACK_PACKAGE_VERSION "1.0.2")
+set (CPACK_PACKAGE_VENDOR "seqan")
+# A description of the project, used in places such as the introduction screen of CPack-generated Windows installers.
+# set (CPACK_PACKAGE_DESCRIPTION_FILE "") # TODO
+set (CPACK_PACKAGE_CHECKSUM "SHA256")
+set (CPACK_RESOURCE_FILE_LICENSE "${needle_SOURCE_DIR}/LICENSE.md")
+set (CPACK_RESOURCE_FILE_README "${needle_SOURCE_DIR}/README.md")
+
+# Source Package
+set (CPACK_SOURCE_GENERATOR "TXZ")
+set (CPACK_SOURCE_IGNORE_FILES "\\\\.git($|/)")
+
+include (CPack)

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.9)

# Set directories for test output files, input data and binaries.
file (MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
add_definitions (-DOUTPUTDIR=\"${CMAKE_CURRENT_BINARY_DIR}/output/\")
add_definitions (-DDATADIR=\"${CMAKE_CURRENT_BINARY_DIR}/data/\")
add_definitions (-DBINDIR=\"${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/\")
add_definitions (-DDATA_INPUT_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/data/\")

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (APP_TEMPLATE_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND APP_TEMPLATE_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND APP_TEMPLATE_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND APP_TEMPLATE_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND APP_TEMPLATE_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")

# Define cmake configuration flags to configure and build external projects with the same flags as specified for
# this project.
set (SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}")
list (APPEND SEQAN3_EXTERNAL_PROJECT_CMAKE_ARGS "-DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}")
set (SEQAN3_TEST_CLONE_DIR "${PROJECT_BINARY_DIR}/vendor/googletest")

include ("${SEQAN3_CLONE_DIR}/test/cmake/seqan3_require_test.cmake")

seqan3_require_test ()

# Build tests just before their execution, because they have not been built with "all" target.
# The trick is here to provide a cmake file as a directory property that executes the build command.
file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/build_test_targets.cmake"
            "execute_process(COMMAND ${CMAKE_COMMAND} --build . --target api_test)\n"
            "execute_process(COMMAND ${CMAKE_COMMAND} --build . --target cli_test)")
set_directory_properties (PROPERTIES TEST_INCLUDE_FILE "${CMAKE_CURRENT_BINARY_DIR}/build_test_targets.cmake")

# Define the test targets. All depending targets are built just before the test execution.
add_custom_target (api_test)
add_custom_target (cli_test)

# Test executables and libraries should not mix with the application files.
unset (CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
unset (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset (CMAKE_RUNTIME_OUTPUT_DIRECTORY)

# A macro that adds an api or cli test.
macro (add_app_test test_filename test_alternative)
    # Extract the test target name.
    file (RELATIVE_PATH source_file "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_LIST_DIR}/${test_filename}")
    get_filename_component (target "${source_file}" NAME_WE)

    # Create the test target.
    add_executable (${target} ${test_filename})
    target_link_libraries (${target} "${PROJECT_NAME}_lib" seqan3::seqan3 gtest gtest_main)

    # Make seqan3::test available for both cli and api tests.
    target_include_directories(${target} PUBLIC "${SEQAN3_CLONE_DIR}/test/include")
    target_include_directories(${target} PUBLIC "${SEQAN3_TEST_CLONE_DIR}/googletest/include/")

    # Make seqan3::test available for both cli and api tests.
    target_include_directories(${target} PUBLIC "${SEQAN3_CLONE_DIR}/test/include")

    # Add the test to its general target (cli or api).
    if (${test_alternative} STREQUAL "CLI_TEST")
        add_dependencies (${target} "${PROJECT_NAME}") # cli test needs the application executable
        add_dependencies (cli_test ${target})
    elseif (${test_alternative} STREQUAL "API_TEST")
        add_dependencies (api_test ${target})
    endif ()

    # Generate and set the test name.
    get_filename_component (target_relative_path "${source_file}" DIRECTORY)
    if (target_relative_path)
        set (test_name "${target_relative_path}/${target}")
    else ()
        set (test_name "${target}")
    endif ()
    add_test (NAME "${test_name}" COMMAND ${target})

    unset (source_file)
    unset (target)
    unset (test_name)
endmacro ()

# A macro that adds an api test.
macro (add_api_test test_filename)
    add_app_test (${test_filename} API_TEST)
endmacro ()

# A macro that adds a cli test.
macro (add_cli_test test_filename)
    add_app_test (${test_filename} CLI_TEST)
endmacro ()

# Fetch data and add the tests.
include (data/datasources.cmake)
add_subdirectory (api)
add_subdirectory (cli)
add_subdirectory (coverage)

message (STATUS "${FontBold}You can run `make test` to build and run tests.${FontReset}")

=== lib/robin-hood-hashing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robin-hood-hashing LANGUAGES CXX)

# determine whether this is a standalone project or included by other projects
set(RH_STANDALONE_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(RH_STANDALONE_PROJECT ON)
endif ()

if (RH_STANDALONE_PROJECT)
    option(RH_sanitizer "Address sanitizer" OFF)
    option(RH_coverage "Enable coverage" OFF)
    set(RH_cxx_standard "14" CACHE STRING "C++ standard, e.g. 11, 14, 17")

    set(CMAKE_CXX_STANDARD ${RH_cxx_standard})
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_EXTENSIONS OFF)

    # configuration see .clang-tidy
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        # set(CMAKE_CXX_CLANG_TIDY clang-tidy-6)
        set(CMAKE_CXX_CLANG_TIDY clang-tidy)
    endif()

    find_program(CCACHE_PROGRAM ccache)
    if(CCACHE_PROGRAM)
        SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
    endif(CCACHE_PROGRAM)

    add_executable(rh "")

    if (RH_no_exceptions)
        target_compile_options(rh PRIVATE -fno-exceptions)
        target_link_libraries(rh PRIVATE -fno-exceptions)
        add_definitions(-DDOCTEST_CONFIG_NO_EXCEPTIONS_BUT_WITH_ALL_ASSERTS)
    endif()

    if (RH_sanitizer)
        if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            # see https://clang.llvm.org/docs/UndefinedBehaviorSanitizer.html#silencing-unsigned-integer-overflow
            # Compile with -g and -fno-omit-frame-pointer to get proper debug information in your binary
            target_compile_options(rh PRIVATE -g)
            target_compile_options(rh PRIVATE -O2)
            target_compile_options(rh PRIVATE -fno-omit-frame-pointer)

            target_compile_options(rh PRIVATE -fsanitize=address)
            target_link_libraries(rh PRIVATE -fsanitize=address)

            target_compile_options(rh PRIVATE -fsanitize=undefined)
            target_link_libraries(rh PRIVATE -fsanitize=undefined)

            target_compile_options(rh PRIVATE -fsanitize=integer)
            target_compile_options(rh PRIVATE -fno-sanitize=unsigned-integer-overflow)
            target_link_libraries(rh PRIVATE -fsanitize=integer)
            target_link_libraries(rh PRIVATE -fno-sanitize=unsigned-integer-overflow)

            target_compile_options(rh PRIVATE -fsanitize=nullability)
            target_link_libraries(rh PRIVATE -fsanitize=nullability)
        endif()
        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
            # need to use gold linker, otherwise travis gets '/usr/bin/ld: --push-state: unknown option' error
            target_link_libraries(rh PRIVATE -fuse-ld=gold)

            target_compile_options(rh PRIVATE -g)
            target_compile_options(rh PRIVATE -O2)
            target_compile_options(rh PRIVATE -fno-omit-frame-pointer)

            target_compile_options(rh PRIVATE -fsanitize=undefined,float-divide-by-zero,float-cast-overflow)
            target_link_libraries(rh PRIVATE -fsanitize=undefined,float-divide-by-zero,float-cast-overflow)

            target_compile_options(rh PRIVATE -fsanitize=pointer-compare,pointer-subtract)
            target_link_libraries(rh PRIVATE -fsanitize=pointer-compare,pointer-subtract)

            target_compile_options(rh PRIVATE -fsanitize=address)
            target_link_libraries(rh PRIVATE -fsanitize=address)
        endif()
    endif()

    if(RH_coverage AND CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        MESSAGE(STATUS "Coverage enable")

        # Add required flags (GCC & LLVM/Clang)
        target_compile_options(rh PRIVATE -fprofile-arcs -ftest-coverage)
        target_link_libraries(rh PRIVATE -fprofile-arcs -ftest-coverage)

        # find the correct gcov version
        #get_filename_component(COMPILER_PATH "${CMAKE_CXX_COMPILER}" PATH)
        #string(REGEX MATCH "^[0-9]+" GCC_VERSION "${CMAKE_CXX_COMPILER_VERSION}")
        #find_program(GCOV_BIN NAMES gcov-${GCC_VERSION} gcov HINTS ${COMPILER_PATH})

        # collect all source files from the chosen include dir
        file(GLOB_RECURSE SOURCE_FILES src/include/robin_hood.h)

        # COMMAND ${CMAKE_SOURCE_DIR}/test/thirdparty/imapdl/filterbr.py json.info.filtered > json.info.filtered.noexcept
        add_custom_target(lcov
            COMMAND lcov --directory . --capture --output-file coverage.info # parse coverage data
            COMMAND lcov -e coverage.info ${SOURCE_FILES} --output-file coverage.info # filter
            COMMAND coveralls-lcov coverage.info  # upload results
        )

    endif()

    #set_target_properties(rh PROPERTIES COMPILE_FLAGS "-m32" LINK_FLAGS "-m32")
    #set_target_properties(rh PROPERTIES COMPILE_FLAGS "-m64" LINK_FLAGS "-m64")

    add_subdirectory(cmake)

    add_compile_flags_target(rh)
    add_subdirectory(src)

    target_sources_local(rh PUBLIC .clang-tidy)
else()
    # creates a library robin_hood which is an interface (header files only)
    add_library(robin_hood INTERFACE)
    add_library(robin_hood::robin_hood ALIAS robin_hood)

    target_include_directories(robin_hood INTERFACE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/include>
        $<INSTALL_INTERFACE:src/include>
    )
endif()

=== test/api/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 # The api_test build target.
 add_api_test (count_test.cpp)
+add_api_test (insert_delete_test.cpp)
 add_api_test (estimate_test.cpp)
 add_api_test (ibf_test.cpp)
 add_api_test (ibfmin_test.cpp)

=== test/cli/CMakeLists.txt ===
--- 
+++ 
@@ -12,3 +12,4 @@
 add_cli_test (count_options_test.cpp)
 target_use_datasources (count_options_test FILES mini_example.fasta mini_gen.fasta mini_gen.genome)
 add_cli_test (delete_options_test.cpp)
+target_use_datasources (delete_options_test FILES exp_01.fasta)

=== lib/robin-hood-hashing/cmake/CMakeLists.txt ===
# NOTE: This helper function assumes no generator expressions are used for the source files
# source: https://crascit.com/2016/01/31/enhanced-source-file-handling-with-target_sources/
function(target_sources_local target)
  if(POLICY CMP0076)
    # New behavior is available, so just forward to it by ensuring
    # that we have the policy set to request the new behavior, but
    # don't change the policy setting for the calling scope
    cmake_policy(PUSH)
    cmake_policy(SET CMP0076 NEW)
    target_sources(${target} ${ARGN})
    cmake_policy(POP)
    return()
  endif()

  # Must be using CMake 3.12 or earlier, so simulate the new behavior
  unset(_srcList)
  get_target_property(_targetSourceDir ${target} SOURCE_DIR)

  foreach(src ${ARGN})
    if(NOT src STREQUAL "PRIVATE" AND
       NOT src STREQUAL "PUBLIC" AND
       NOT src STREQUAL "INTERFACE" AND
       NOT IS_ABSOLUTE "${src}")
      # Relative path to source, prepend relative to where target was defined
      file(RELATIVE_PATH src "${_targetSourceDir}" "${CMAKE_CURRENT_LIST_DIR}/${src}")
    endif()
    list(APPEND _srcList ${src})
  endforeach()
  target_sources(${target} ${_srcList})
endfunction()

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
endif(CCACHE_PROGRAM)

MESSAGE(STATUS "${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}, C++${CMAKE_CXX_STANDARD}, sanitizer ${RH_sanitizer}, CMAKE_CXX_FLAGS=${CMAKE_CXX_FLAGS}")

function(add_compile_flags_target target)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
        target_compile_options(${target} PRIVATE -march=native)
        target_compile_options(${target} PRIVATE -fdiagnostics-color)
        target_compile_options(${target} PRIVATE -Werror)
        target_compile_options(${target} PRIVATE -pedantic)
        target_compile_options(${target} PRIVATE -pedantic-errors)
        target_compile_options(${target} PRIVATE -fvisibility=hidden)
        target_compile_options(${target} PRIVATE -fstrict-aliasing)
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        target_compile_options(${target} PRIVATE -Wall)
        target_compile_options(${target} PRIVATE -Wextra)
        target_compile_options(${target} PRIVATE -fdiagnostics-show-option)
        target_compile_options(${target} PRIVATE -Wconversion)
        target_compile_options(${target} PRIVATE -Wold-style-cast)
        target_compile_options(${target} PRIVATE -Wfloat-equal)
        target_compile_options(${target} PRIVATE -Wlogical-op)
        target_compile_options(${target} PRIVATE -Wundef)
        target_compile_options(${target} PRIVATE -Wredundant-decls)
        target_compile_options(${target} PRIVATE -Wshadow)
        target_compile_options(${target} PRIVATE -Wstrict-overflow=2)
        target_compile_options(${target} PRIVATE -Wwrite-strings)
        target_compile_options(${target} PRIVATE -Wpointer-arith)
        target_compile_options(${target} PRIVATE -Wcast-qual)
        target_compile_options(${target} PRIVATE -Wformat=2)
        # target_compile_options(${target} PRIVATE -Wswitch-default)
        target_compile_options(${target} PRIVATE -Wmissing-include-dirs)
        target_compile_options(${target} PRIVATE -Wcast-align)
        target_compile_options(${target} PRIVATE -Wswitch-enum)
        target_compile_options(${target} PRIVATE -Wnon-virtual-dtor)
        target_compile_options(${target} PRIVATE -Wctor-dtor-privacy)
        target_compile_options(${target} PRIVATE -Wsign-conversion)
        target_compile_options(${target} PRIVATE -Wdisabled-optimization)
        target_compile_options(${target} PRIVATE -Weffc++)
        # target_compile_options(${target} PRIVATE -Winline)
        target_compile_options(${target} PRIVATE -Winvalid-pch)
        target_compile_options(${target} PRIVATE -Wmissing-declarations)
        target_compile_options(${target} PRIVATE -Woverloaded-virtual)

        if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
            target_compile_options(${target} PRIVATE -Wnoexcept)
        endif()

        # no way to silence it in the expression decomposition macros: _Pragma() in macros doesn't work for the c++ front-end of g++
        # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=55578
        # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=69543
        # Also the warning is completely worthless nowadays - http://stackoverflow.com/questions/14016993
        #target_compile_options(${target} PRIVATE -Waggregate-return)

        if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
            target_compile_options(${target} PRIVATE -Wdouble-promotion)
            target_compile_options(${target} PRIVATE -Wtrampolines)
            target_compile_options(${target} PRIVATE -Wzero-as-null-pointer-constant)
            #target_compile_options(${target} PRIVATE -Wuseless-cast)
            target_compile_options(${target} PRIVATE -Wvector-operation-performance)
        endif()

        if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
            target_compile_options(${target} PRIVATE -Wshift-overflow=2)
            target_compile_options(${target} PRIVATE -Wnull-dereference)
            target_compile_options(${target} PRIVATE -Wduplicated-cond)
        endif()

        if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
            target_compile_options(${target} PRIVATE -Walloc-zero)
            target_compile_options(${target} PRIVATE -Walloca)
            target_compile_options(${target} PRIVATE -Wduplicated-branches)
        endif()

        if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8.0)
            target_compile_options(${target} PRIVATE -Wcast-align=strict)
        endif()
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        target_compile_options(${target} PRIVATE -Weverything)
        target_compile_options(${target} PRIVATE -Wno-c++98-compat)
        target_compile_options(${target} PRIVATE -Wno-c++98-compat-pedantic)
        target_compile_options(${target} PRIVATE -Wno-c++98-compat-bind-to-temporary-copy)
        target_compile_options(${target} PRIVATE -Wno-c++98-compat-local-type-template-args)
        target_compile_options(${target} PRIVATE -Qunused-arguments -fcolor-diagnostics) # needed for ccache integration on travis
    endif()

    if(MSVC)
        target_compile_options(${target} PRIVATE /EHsc) # exception handling
        target_compile_options(${target} PRIVATE /std:c++latest) # for post c++14 updates in MSVC
        target_compile_options(${target} PRIVATE /permissive-)   # force standard conformance - this is the better flag than /Za
        target_compile_options(${target} PRIVATE /WX)
        target_compile_options(${target} PRIVATE /Wall) # turns on warnings from levels 1 through 4 which are off by default - https://msdn.microsoft.com/en-us/library/23k5d385.aspx
        
        add_definitions(/MP) # parallel builds

        target_compile_options(${target} PRIVATE 
            /wd4514 # unreferenced inline function has been removed
            /wd4571 # SEH related
            /wd4710 # function not inlined
            /wd4711 # function 'x' selected for automatic inline expansion
            
            /wd4616 # invalid compiler warnings - https://msdn.microsoft.com/en-us/library/t7ab6xtd.aspx
            /wd4619 # invalid compiler warnings - https://msdn.microsoft.com/en-us/library/tacee08d.aspx
            
            /wd4820 # padding in structs
            /wd4625 # copy constructor was implicitly defined as deleted
            /wd4626 # assignment operator was implicitly defined as deleted
            /wd5027 # move assignment operator was implicitly defined as deleted
            /wd5026 # move constructor was implicitly defined as deleted
            /wd4623 # default constructor was implicitly defined as deleted
            /wd4774 # 'swprintf_s' : format string expected in argument 3 is not a string literal

            /wd5045 # Compiler will insert Spectre mitigation for memory load if /Qspectre switch specified
        )
    endif()

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|AppleClang|GNU" )
        target_compile_options(${target} PRIVATE -fdiagnostics-color -ggdb -g)

        # enable lots of warning checking
        #target_compile_options(robinhood-test PRIVATE -Werror -Wall -Wextra -Weffc++ -Wconversion -Wunreachable-code -Wuninitialized -Wshadow -Wfloat-equal -Wmissing-braces)

        # make sure OpenMP in the tests work
        #target_compile_options(robinhood-test PRIVATE -fopenmp)
        #target_link_libraries(robinhood-test PRIVATE -fopenmp)

        #target_compile_options(robinhood-test PRIVATE -fsanitize=undefined,float-divide-by-zero,float-cast-overflow)
        #target_link_libraries(robinhood-test PRIVATE -fsanitize=undefined,float-divide-by-zero,float-cast-overflow)

        #target_compile_options(robinhood-test PRIVATE -fsanitize=address)
        #target_link_libraries(robinhood-test PRIVATE -fsanitize=address)

        # warns in doctest.h :(
        #target_compile_options(robinhood-test PRIVATE -fsanitize=memory)
        #target_link_libraries(robinhood-test PRIVATE -fsanitize=memory)
    endif()
endfunction()

=== lib/robin-hood-hashing/src/test/CMakeLists.txt ===
add_subdirectory(app)
add_subdirectory(thirdparty)
add_subdirectory(unit)

target_include_directories(rh PRIVATE ${CMAKE_CURRENT_LIST_DIR})

=== lib/robin-hood-hashing/src/test/unit/CMakeLists.txt ===
target_sources_local(rh PRIVATE
    main.cpp # first because its slowest

    # benchmarks
    bench_copy_iterators.cpp
    bench_distinctness.cpp
    bench_find_random.cpp
    bench_hash_int.cpp
    bench_hash_string.cpp
    bench_iterate.cpp
    bench_quick_overall_map.cpp
    bench_quick_overall_set.cpp
    bench_random_insert_erase.cpp
    bench_swap.cpp

    # count
    count_ctor_dtor.cpp
    count_ctor_dtor_1.cpp
    count_random_insert_erase.cpp
    count_find_random.cpp
    count_one_emplace.cpp

    # fuzzers
    fuzz_insert_erase.cpp

    # optimizations
    optimize_avalanche.cpp

    # show infos
    show_hash.cpp

    # unit tests
    unit_addOrFree.cpp
    unit_assertNotNull.cpp
    unit_assign_to_move.cpp
    unit_assignments.cpp
    unit_assignment_combinations.cpp
    unit_at.cpp
    unit_calcMaxNumElementsAllowed.cpp
    unit_clz.cpp
    unit_constexpr_hash.cpp
    unit_calcsize.cpp
    unit_copyassignment.cpp
    unit_count.cpp
    unit_diamond.cpp
    unit_empty.cpp
    include_only.h
    include_only.cpp
    unit_include_only.cpp
    unit_initializerlist.cpp
    unit_iterator_twice_bug.cpp
    unit_iterators_ctor.cpp
    unit_iterators_empty.cpp
    unit_iterators_erase.cpp
    unit_iterators_insert.cpp
    unit_iterators_stochastic.cpp
    unit_load_factor.cpp
    unit_maps_of_maps.cpp
    unit_multiple_apis.cpp
    unit_mup.cpp
    unit_not_copyable.cpp
    unit_not_moveable.cpp
    unit_overflow.cpp
    unit_overflow_collisions.cpp
    unit_pair_trivial.cpp
    unit_random_verifier.cpp
    unit_reserve_and_assign.cpp
    unit_reserve.cpp
    unit_sfc64_is_deterministic.cpp
    unit_sizeof.cpp
    unit_undefined_behavior_nekrolm.cpp
    unit_unique_ptr.cpp
    unit_unordered_set.cpp
    unit_vectorofmaps.cpp
)

=== debian/changelog ===
seqan-needle (1.0.2+ds-2) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * d/clean: remove HTML build of the documentation. Closes: #1048377
  * corrected some patch metadata.

  [ Komolehin Israel Timilehin ]
  * Added Autopkgtest

 -- Komolehin Israel Timilehin <komolehinisrael@gmail.com>  Mon, 08 Jan 2024 11:38:37 +0100

seqan-needle (1.0.2+ds-1) unstable; urgency=medium

  * d/watch: find the complete source archives
  * New upstream version
  * d/rules: set "-O3" to match a normal release build.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 04 Sep 2023 17:57:09 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libcereal-dev,
                pkg-config,
                doxygen <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle
 Vcs-Git: https://salsa.debian.org/med-team/seqan-needle.git
 Homepage: https://github.com/seqan/needle

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # DH_VERBOSE := 1
 export LC_ALL=C.UTF-8
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_CFLAGS_MAINT_APPEND=-O3
+export DEB_CXXFLAGS_MAINT_APPEND=-O3
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk

=== debian/tests/control ===
Tests: run-unit-tests
Depends: build-essential, cmake, libseqan3-dev, libgtest-dev, libcereal-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="searchmode=plain,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%,dversionmangle=auto,repacksuffix=+ds" \
  https://api.github.com/repos/seqan/needle/releases https://github.com/seqan/needle/releases/download/(?:.*?/)?needle-@ANY_VERSION@-Source@ARCHIVE_EXT@

## seqan-needle 1.0.3~rc.2+ds

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

# Define the application name and version.
project (needle
         LANGUAGES CXX
         VERSION 1.0.3
         DESCRIPTION "A fast and space-efficient pre-filter for estimating the quantification of very large collections of nucleotide sequences"
)

# This allows including `*.cmake` files from the `cmake` directory without specifying the full path.
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Specify the directories where to store the built archives, libraries and executables.
include (output_directories)

# An option to disable configuring and building the tests. Tests are enabled by default.
# If your project-name (line 8 of this file) is `app-template`, the option will be `app-template_TEST`.
# It can be used when calling CMake: `cmake .. -Dapp-template_TEST=OFF`.
# It is good practice to allow disabling tests. If another project includes your application,
# it might not want to build your tests.
option (NEEDLE_TEST "Enable testing for NEEDLE." ON)
option (NEEDLE_DOCS "Enable documentation for NEEDLE." OFF)
option (NEEDLE_PACKAGE "Enable packaging for NEEDLE." OFF)

if (NEEDLE_PACKAGE)
    set (CPM_SOURCE_CACHE "${CMAKE_CURRENT_BINARY_DIR}/vendor")
    set (CPM_USE_LOCAL_PACKAGES OFF)
    include (package)
elseif (EXISTS "${CMAKE_CURRENT_LIST_DIR}/vendor")
    set (CPM_SOURCE_CACHE "${CMAKE_CURRENT_LIST_DIR}/vendor")
endif ()

# Add packages.
# We use CPM for package management: https://github.com/cpm-cmake/CPM.cmake
# The added packages (e.g., hibf, sharg, seqan3) are defined in the `cmake/package-lock.cmake` file.
include (CPM)
CPMUsePackageLock (${CMAKE_CURRENT_LIST_DIR}/cmake/package-lock.cmake)

# Use ccache if available. This speeds up the build process by caching files that have been compiled before.
CPMGetPackage (use_ccache)
CPMGetPackage (seqan3)
CPMGetPackage (robin-hood)

# Add the application. This will include `src/CMakeLists.txt`.
add_subdirectory (src)

if (NEEDLE_TEST)
    # Add the tests. This will include `test/CMakeLists.txt`.
    add_subdirectory (test EXCLUDE_FROM_ALL)
endif ()

if (NEEDLE_DOCS)
    add_subdirectory (doc EXCLUDE_FROM_ALL)
endif ()

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

find_package (OpenMP REQUIRED COMPONENTS CXX)
add_library ("${PROJECT_NAME}_lib" STATIC estimate.cpp ibf.cpp)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC seqan3::seqan3)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC robin_hood::robin_hood)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC OpenMP::OpenMP_CXX)
target_include_directories ("${PROJECT_NAME}_lib" PUBLIC ../include)

add_executable ("${PROJECT_NAME}" main.cpp)
target_link_libraries ("${PROJECT_NAME}" PRIVATE "${PROJECT_NAME}_lib")
set_target_properties ("${PROJECT_NAME}" PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

include (GNUInstallDirs)
install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

option (NEEDLE_WITH_WERROR "Report compiler warnings as errors." ON)

if (NEEDLE_WITH_WERROR)
    target_compile_options (${PROJECT_NAME}_lib PUBLIC "-Werror")
endif ()

=== test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

# This includes `cmake/test/config.cmake` which takes care of setting up the test infrastructure. It also provides
# the `add_app_test` macro, which is used to add tests to the CMake test suite.
include (test/config)

# This includes `test/data/datasources.cmake`, which makes test data available to the tests.
include (data/datasources.cmake)

add_subdirectory (api)
add_subdirectory (cli)

message (STATUS "You can run `make tests` to build tests.")
message (STATUS "You can run `make check` to build and run tests.")

=== debian/changelog ===
seqan-needle (1.0.3~rc.2+ds-2) unstable; urgency=medium

  * Fix arch: all build
  * d/control: Restrict to 64-bit little-endian systems.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 09 Nov 2024 16:29:51 +0100

seqan-needle (1.0.3~rc.2+ds-1) unstable; urgency=medium

  * d/watch: rewrite RC versions to Debian style
  * d/copyright: match new layout
  * New upstream version. Closes: #1086625
  * Drop a patch applied upstream, and another that is no longer needed.
  * d/rules: use CPM_USE_LOCAL_PACKAGES=On
  * d/seqan-needle.install: update path
  * Added patch to find and use libseqan3-dev
  * Autopkgtests: build and run agains the installed needle binary.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 07 Nov 2024 17:28:29 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,14 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
                cmake,
                libseqan3-dev (>= 3.2.0+ds-5),
                libgtest-dev,
                libcereal-dev,
                pkg-config,
+               git,
                doxygen <!nodoc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle

=== debian/rules ===
--- 
+++ 
@@ -11,17 +11,21 @@
 %:
 	dh $@
 
-override_dh_auto_configure:
-	rm -Rf lib/seqan3
-	dh_auto_configure -- -DSEQAN3_NO_LEMON=OFF
+override_dh_auto_configure-indep:
+	echo I: No configuration needed for the docs
 
-override_dh_auto_build-arch:
-	dh_auto_build --arch
+override_dh_auto_configure-arch:
+	dh_auto_configure --arch -- -DSEQAN3_NO_LEMON=OFF -DCPM_USE_LOCAL_PACKAGES=On
+
+execute_after_dh_auto_build-arch:
 	obj-*/bin/needle --export-help man > debian/needle.1
 	obj-*/bin/needle count --export-help man > debian/needle-count.1
 	obj-*/bin/needle estimate --export-help man > debian/needle-estimate.1
 	obj-*/bin/needle ibf --export-help man > debian/needle-ibf.1
 	obj-*/bin/needle minimiser --export-help man > debian/needle-minimiser.1
+
+execute_after_dh_auto_test:
+	rm -Rf obj-*/test
 
 override_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
@@ -29,4 +33,4 @@
 endif
 
 override_dh_auto_test-indep:
-	echo "Do Nothing"
+	echo I: Not running tests for the docs

## seqan-needle 1.0.3%2Bds

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-cmake_minimum_required (VERSION 3.9)
+# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
+# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
+# SPDX-License-Identifier: BSD-3-Clause
+
+cmake_minimum_required (VERSION 3.25...3.30)
 
 # Find doxygen.
 find_package (Doxygen 1.9.4 QUIET)
@@ -8,7 +12,7 @@
 
     # Configure doxygen options.
     set (APP_TEMPLATE_DOXYFILE_IN ${CMAKE_SOURCE_DIR}/doc/doxygen_cfg)
-    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}/doc")
+    set (APP_TEMPLATE_DOXYGEN_OUTPUT_DIR "${PROJECT_BINARY_DIR}")
     set (APP_TEMPLATE_DOXYGEN_EXCLUDE_SYMBOLS "")
     set (APP_TEMPLATE_DOXYGEN_PREDEFINED_NDEBUG "")
     set (APP_TEMPLATE_DOXYGEN_ENABLED_SECTIONS "DEV")
@@ -19,7 +23,8 @@
                        COMMAND ${DOXYGEN_EXECUTABLE}
                        WORKING_DIRECTORY ${APP_TEMPLATE_DOXYGEN_OUTPUT_DIR}
                        COMMENT "Generating (developer) API documentation with Doxygen."
-                       VERBATIM)
+                       VERBATIM
+    )
     message (STATUS "${FontBold}You can run `make doc` to build api documentation.${FontReset}")
 else ()
     message (STATUS "Doxygen not found.")

=== test/api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

add_app_test (count_test.cpp)
add_app_test (insert_delete_test.cpp)
add_app_test (estimate_test.cpp)
add_app_test (ibf_test.cpp)
add_app_test (ibfmin_test.cpp)
add_app_test (minimiser_test.cpp)
